#include <iostream>
#include <vector>
#include<algorithm>

using namespace std;
vector<vector<int>>gp;
vector<int>vis;
vector<int>v;
void dfs(int u) {
    vis[u] = 1;
    for (int& x : gp[u]) {
        if (vis[x] == 0) {
            dfs(x);
        }
    }
    v.push_back(u);
}
void solve() {
    v.clear();
    int n, m; cin >> n >> m;
    gp = vector<vector<int>>(n);
    vis = vector<int>(n);
    for (int i = 0;i < m;i++) {
        int u, v1; cin >> u >> v1;
        --u, --v1;
        gp[u].push_back(v1);
    }
    for (int i = 0;i < n;i++) {
        if (vis[i] == 0)dfs(i);
    }
    reverse(v.begin(), v.end());
    for (int i = 0;i < v.size();i++) {
        cout << v[i]+1 << " ";
    }
    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
   int t;cin >> t;while (t--)
        solve();
}
