#include <iostream>
#include <vector>
#include<algorithm>
#include<ctime>
using namespace std;
vector<vector<int>>gp;
vector<int>vis;
vector<int>v;
void dfs(int u) {
    vis[u] = 1;
    for (int& x : gp[u]) {
        if (vis[x] == 0) {
            dfs(x);
        }
    }
    v.push_back(u);
}
void solve() {
    //mt19937 arm(time(0));
    int n, m; cin >> n >> m;
    gp = vector<vector<int>>(n);
    for (int i = 0;i < m;i++) {
        int u, v1; cin >> u >> v1;
        --u, --v1;
        gp[u].push_back(v1);
    }
    for (int j = 0;j < min(n, 300);j++) {
        vis = vector<int>(n);
        vector<int>ind(n);
        v.clear();
        for (int i = j;i < n;i++) {
            if (vis[i] == 0)dfs(i);
        }
        for (int i = 0;i < j;i++) {
            if (vis[i] == 0)dfs(i);
        }
        reverse(v.begin(), v.end());
        //cout << "STE" << endl;
        for (int i = 0;i < v.size();i++) {
            ind[v[i]] = i;
            //cout << v[i] << " ";
        }
        //cout << endl;

        int cnt = 0;
        for (int i = 0;i < n;i++) {
            for (int x : gp[v[i]]) {
                if (ind[x] > i)cnt++;
            }
        }
        if (cnt >= (m + 1) / 2) {
            for (int i = 0;i < v.size();i++) {
                cout << v[i] + 1 << " ";
            }
            cout << endl;
            return;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
   int t;cin >> t;while (t--)
        solve();
}
