//#include <iostream>
//#include <algorithm>
//#include <string>
//#include <cstring>
//#include <vector>
//#include <set>
//
//using namespace std;
//
//const int N = 105;
//const int inf = 1000 * 1000 * 1000;
//const int mod = 998244353;
//const double eps = 1e-9;
//
//int t;
//int n, m, k;
//string w;
//
//int dp[2][(1 << 16) + 5][(1 << 3) + 5][2];
//
//int first[(1 << 16) + 5];
//int second[(1 << 16) + 5];
//
//void maybe_update(int len, int xx) {
//	for (int j = 0; j < (1 << xx); j++) {
//		for (int h = 0; h < (1 << k); h++) {
//			if (n == len) {
//				first[j] += dp[len % 2][j][h][1];
//				first[j] %= mod;
//			}
//			if (m == len) {
//				second[j] += dp[len % 2][j][h][1];
//				second[j] %= mod;
//			}
//		}
//	}
//}
//
//int main() {
//	ios_base::sync_with_stdio(false);
//	cin.tie(NULL);
//
//	/*cin >> t;
//	while (t--) {
//		cin >> n;
//
//		long long all_b = 0;
//		long long all_r = 0;
//
//		for (int i = 1; i <= n; i++) {
//			cin >> x[i] >> cnt[i] >> c[i];
//			if (c[i] == 'r') {
//				all_r += cnt[i];
//			}
//			else {
//				all_b += cnt[i];
//			}
//		}
//
//		if (all_r == all_b) {
//			cout << "draw 0 0" << endl;
//			continue;
//		}
//
//		if (all_r < all_b) {
//			vector < pair<int, int> > st;
//
//			long long total = 0;
//			long long counter = 0;
//
//			for (int i = n; i >= 1; i--) {
//				if (c[i] == 'r') {
//					counter += cnt[i];
//				}
//				else {
//					counter -= cnt[i];
//					total += cnt[i] * 1ll * c[i];
//				}
//
//				if (counter > 0) {
//					
//				}
//				else {
//					total -= cnt[i] * 1ll * c[i];
//				}
//			}
//			
//			if (c[n] == 'r') {
//				cout << "draw " << x[n] << " +" << endl;
//				continue;
//			}
//
//
//
//			continue;
//		}
//
//
//	}*/
//
//	cin >> n >> m >> k;
//	cin >> w;
//
//	int xx = (1 << (k + 1));
//
//	int mask = 0;
//	for (int i = 0; i < k; i++) {
//		mask = mask * 2 + w[i] - '0';
//	}
//
//	for (int i = 0; i < (1 << k); i++) {
//		dp[k % 2][0][i][(mask == i)] = 1;
//	}
//	maybe_update(k, xx);
//
//	for (int i = k + 1; i <= max(n, m); i++) {
//		int v = i % 2;
//
//		for (int j = 0; j < (1 << xx); j++) {
//			for (int h = 0; h < (1 << k); h++) {
//				int new_h;
//				if (h >= (1 << (k - 1))) {
//					new_h = h - (1 << (k - 1));
//				}
//				else {
//					new_h = h;
//				}
//				new_h *= 2;
//
//				for (int k = 0; k < 2; k++) {
//					for (int new_bit = 0; new_bit < 2; new_bit++) {
//						// adding `new_bit` from back
//						int val = h * 2 + new_bit;
//
//						int jj = (j | (1 << val));
//						int hh = new_h + new_bit;
//						int kk = (k | (hh == mask));
//
//						dp[1 - v][jj][hh][kk] += dp[v][j][h][k];
//						dp[1 - v][jj][hh][kk] %= mod;
//					}
//				}
//			}
//		}
//
//		maybe_update(k, xx);
//
//		for (int j = 0; j < (1 << xx); j++) {
//			for (int h = 0; h < (1 << k); h++) {
//				dp[1 - v][j][h][0] = 0;
//				dp[1 - v][j][h][1] = 0;
//			}
//		}
//	}
//
//	int answ = 0;
//	for (int m = 0; m < (1 << xx); m++) {
//		for (int s = m; s; s = (s - 1) & m) {
//			int A = s;
//			int B = (s ^ m);
//
//			answ += first[A] * 1ll * second[B] % mod;
//			answ %= mod;
//		}
//	}
//
//	cout << answ << endl;
//
//	cin >> n;
//	return 0;
//}


#include <iostream>
#include <vector>

using namespace std;

const long long mod = 998244353;
const int N = 200000;

long long f[N], g[N];

long long solve(int n, int id, vector<int>& to) {
	if (n == 0) {
		return 0;
	}
	if (n == 1) {
		return abs(id - to[n]);
	}

	if (to[n] == id)
		return solve(n - 1, id, to);

	if (id == 2) {
		return (g[n - 1] + 1 + solve(n - 1, 4 - to[n], to)) % mod;
	}
	else if (abs(id - to[n]) == 1) {
		return (f[n - 1] + 1 + solve(n - 1, 4 - id, to)) % mod;
	}
	else {
		return (2 * f[n - 1] + 2 + solve(n - 1, id, to)) % mod;
	}
}

int main() {
	f[1] = 2;
	g[1] = 1;
	for (int i = 2; i < 10; i++) {
		f[i] = (f[i - 1] * 3 + 2) % mod;
		g[i] = (g[i - 1] * 3 + 1) % mod;
	}

	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<int> a(n + 1), b(n + 1);

		for (int i = 1; i <= n; i++) {
			cin >> a[i];
		}

		for (int i = 1; i <= n; i++) {
			cin >> b[i];
		}

		int start_ind = n;
		while (start_ind > 0 && a[start_ind] == b[start_ind]) {
			start_ind--;
		}
		
		if (start_ind == 0) {
			cout << 0 << endl;
		} else if (abs(a[start_ind] - b[start_ind]) == 1) {
			int other_id = 6 - a[start_ind] - b[start_ind];
			cout << (solve(start_ind - 1, other_id, a) + 1 + solve(start_ind - 1, other_id, b)) % mod << endl;
		}
		else {
			cout << (solve(start_ind - 1, b[start_ind], a) + 1 + f[start_ind - 1] + 1 + solve(start_ind - 1, a[start_ind], b)) % mod << endl;
		}
	}
	return 0;

}