#include <iostream>
#include <algorithm>
#include <string>
#include <cstring>
#include <vector>
#include <set>

using namespace std;

const int N = 105;
const int inf = 1000 * 1000 * 1000;
const int mod = 998244353;
const double eps = 1e-9;

int t;
int n, m, k;
string w;

int dp[2][(1 << 16) + 5][(1 << 3) + 5][2];

int first[(1 << 16) + 5];
int second[(1 << 16) + 5];

void maybe_update(int len, int xx) {
	for (int j = 0; j < (1 << xx); j++) {
		for (int h = 0; h < (1 << k); h++) {
			if (n == len) {
				first[j] += dp[len % 2][j][h][1];
				first[j] %= mod;
			}
			if (m == len) {
				second[j] += dp[len % 2][j][h][1];
				second[j] %= mod;
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	/*cin >> t;
	while (t--) {
		cin >> n;

		long long all_b = 0;
		long long all_r = 0;

		for (int i = 1; i <= n; i++) {
			cin >> x[i] >> cnt[i] >> c[i];
			if (c[i] == 'r') {
				all_r += cnt[i];
			}
			else {
				all_b += cnt[i];
			}
		}

		if (all_r == all_b) {
			cout << "draw 0 0" << endl;
			continue;
		}

		if (all_r < all_b) {
			vector < pair<int, int> > st;

			long long total = 0;
			long long counter = 0;

			for (int i = n; i >= 1; i--) {
				if (c[i] == 'r') {
					counter += cnt[i];
				}
				else {
					counter -= cnt[i];
					total += cnt[i] * 1ll * c[i];
				}

				if (counter > 0) {
					
				}
				else {
					total -= cnt[i] * 1ll * c[i];
				}
			}
			
			if (c[n] == 'r') {
				cout << "draw " << x[n] << " +" << endl;
				continue;
			}



			continue;
		}


	}*/

	cin >> n >> m >> k;
	cin >> w;

	int xx = (1 << (k + 1));

	int mask = 0;
	for (int i = 0; i < k; i++) {
		mask = mask * 2 + w[i] - '0';
	}

	for (int i = 0; i < (1 << k); i++) {
		dp[k % 2][0][i][(mask == i)] = 1;
	}
	maybe_update(k, xx);

	for (int i = k + 1; i <= max(n, m); i++) {
		int v = i % 2;

		for (int j = 0; j < (1 << xx); j++) {
			for (int h = 0; h < (1 << k); h++) {
				int new_h;
				if (h >= (1 << (k - 1))) {
					new_h = h - (1 << (k - 1));
				}
				else {
					new_h = h;
				}
				new_h *= 2;

				for (int k = 0; k < 2; k++) {
					for (int new_bit = 0; new_bit < 2; new_bit++) {
						// adding `new_bit` from back
						int val = h * 2 + new_bit;

						int jj = (j | (1 << val));
						int hh = new_h + new_bit;
						int kk = (k | (hh == mask));

						dp[v][jj][hh][kk] += dp[1 - v][j][h][k];
						dp[v][jj][hh][kk] %= mod;
					}
				}
			}
		}

		maybe_update(i, xx);

		for (int j = 0; j < (1 << xx); j++) {
			for (int h = 0; h < (1 << k); h++) {
				dp[1 - v][j][h][0] = 0;
				dp[1 - v][j][h][1] = 0;
			}
		}
	}

	int answ = 0;
	for (int m = 0; m < (1 << xx); m++) {
		for (int s = m; s; s = (s - 1) & m) {
			int A = s;
			int B = (s ^ m);

			answ += first[A] * 1ll * second[B] % mod;
			answ %= mod;
		}
	}

	cout << answ << endl;

	cin >> n;
	return 0;
}
