#include <algorithm>
#include <iostream>
#include <vector>
#include <unordered_map>
using namespace std;

using ll = long long;

int main() {
    int cases;
    cin >> cases;
    while (cases--) {
        int n;
        cin >> n;
        vector<ll> h(n);
        for (int i = 0; i < n; i++) {
            cin >> h[i];
        }
        vector<ll> p(n);
        for (int i = 0; i < n; i++) {
            cin >> p[i];
        }
        unordered_map<ll, ll> m;
        bool is = false;

        for (int i = 0; i < n; i++) {
            if (!m.insert({p[i], h[i]}).second) {
                if (m[p[i]] != h[i]) {
                    is = true;
                    break;
                }
            }
        }
        if (is) { cout << -1 << endl; continue; }
        vector<ll> diff(n);
        for (int i = 0; i < n; i++) {
            diff[i] = p[i] - h[i];
            if (diff[i] < 0) {
                cout << -1 << endl;
                is = true;
            }
        }
        if (!is)
            cout << *max_element(diff.begin(), diff.end()) << endl;
    }
}


