import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int t = scanner.nextInt();
        int[] out = new int[t];
        for(int i = 0; i < t; i++) {
            int n = scanner.nextInt();
            int[] h = new int[n];
            int[] p = new int[n];
            int[] diff = new int[n];
            for(int j = 0; j < n; j++) {
                h[j] = scanner.nextInt();
            }
            for(int j = 0; j < n; j++) {
                p[j] = scanner.nextInt();
                diff[j] = p[j] - h[j];
            }

            sort(p,diff);
            if(diff[0] < 0 || !isSorted(p, diff))
            {
                out[i] = -1;
            }
            else {
                out[i] = diff[n-1];
            }
        }
        for(int i = 0; i < t; i++) {
            System.out.println(out[i]);
        }
    }
    private static void sort(int[] p, int[] diff) {
        int n = p.length;
        for(int i = 1; i < n; i++) {
            int key1 = p[i];
            int key2 = diff[i];
            int j = i-1;
            while(j >= 0 && p[j]>key1) {
                p[j+1] = p[j];
                diff[j+1] = diff[j];
                j = j-1;
            }
            p[j+1] = key1;
            diff[j+1] = key2;
        }
    }

    private static boolean isSorted(int[] p, int[] diff) {
        int n = diff.length;
        for(int i = 0; i < n - 1; i++) {
            if(diff[i] > diff[i+1] || ((diff[i] < diff[i+1]) && (p[i] == p[i+1]))) {
                return false;
            }
        }
        return true;
    }
}