#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;

struct Pair
{
	int first;
	int second;
};

bool operator<(Pair& f, Pair& s)
{
	return f.second < s.second;
}
int main()
{
	int t;
	cin >> t;
	while (t--)
	{
		int n;
		cin >> n;
		vector<Pair> arr(n);

		for (int i = 0; i < n; i++)
		{
			cin >> arr[i].first;
		}

		for (int i = 0; i < n; i++)
		{
			cin >> arr[i].second;
		}

		sort(arr.begin(), arr.end());
		vector<int> dif(n);
		dif[0] = arr[0].second - arr[0].first;

		int ans = 0;


		for (int i = 1; i < n; i++)
		{
			dif[i] = arr[i].second - arr[i].first;
			if ((arr[i].second == arr[i - 1].second && arr[i].first != arr[i - 1].first)
				|| arr[i].first < arr[i - 1].first
				|| arr[i].first > arr[i].second 
				|| arr[i-1].first > arr[i-1].second)
			{
				ans = -1;
				break;               
			}
		}
		if (ans == -1)
		{
			cout << -1 << endl;
			continue;
		}

		for (int i = 1; i < n; i++)
		{
			if (dif[i] < dif[i-1])
			{
				ans = -1;
				break;
			}
		}

		if (ans == -1)
			cout << -1 << endl;
		else
			cout << dif[n-1] <<endl;


	}
}