#include <algorithm>
#include <iostream>
#include <vector>

bool compare(std::pair<int, int> a, std::pair<int, int> b) {
    // int diff = (a.first - b.first) - (a.second - b.second);
    // if (a.first < b.first && a.second < b.second) {
    //     return -diff;
    // }
    // return diff;
    bool flag = false;
    if (a.first - b.first < a.second - b.second) {
        flag = true;
    }
    // return false;
    if (a.first - b.first < 0 && a.second - b.second < 0) {
        flag = !flag;
    }
    return flag;
}

bool compare2(std::pair<int, int> a, std::pair<int, int> b) {
    return !compare(a, b);
}

int main() {
    std::ios_base::sync_with_stdio(false);
    int t;
    std::cin >>t;
    while (t--) {
        int n;
        std::cin >> n;
        std::vector<std::pair<int, int>> v(n);
        for (int i = 0; i < n; i++) {
            std::cin >> v[i].second; // new
        }
        for (int i = 0; i < n; i++) {
            std::cin >> v[i].first;
        }
        bool flag = true;
        for (int i = 0; i < n; ++i) {
            if (v[i].first < v[i].second) {
                flag = false;
                std::cout << -1 << std::endl;
                break;
            }
        }
        if (!flag) {
            continue;
        }


        std::sort(v.begin(), v.end(), compare);
        for (int i = 1; i < n; i++) {
            // if(v[i].first - v[i - 1].first <= 0 &&  v[i].second - v[i - 1].second <= 0) {
            //     continue;
            // }
            if (v[i].first  - v[i - 1].first < v[i].second - v[i - 1].second) {
                std::cout << -1 << std::endl;
                flag = false;
                break;
            }

        }
        if (!flag) {
            continue;
        }


        for (int i = 1; i < n; i++) {
            // if(v[i - 1].first - v[i].first <= 0 &&  v[i - 1].second - v[i].second <= 0) {
            //     continue;
            // }
            if (v[i - 1].first  - v[i].first < v[i - 1].second - v[i].second) {
                std::cout << -1 << std::endl;
                flag = false;
                break;
            }
        }

        if (!flag) {
            continue;
        }

        std::sort(v.begin(), v.end(), compare2);
        for (int i = 1; i < n; i++) {
            if(v[i].first - v[i - 1].first <= 0 &&  v[i].second - v[i - 1].second <= 0) {
                continue;
            }
            if (v[i].first  - v[i - 1].first < v[i].second - v[i - 1].second) {
                std::cout << -1 << std::endl;
                flag = false;
                break;
            }

        }
        if (!flag) {
            continue;
        }


        for (int i = 1; i < n; i++) {
            if(v[i - 1].first - v[i].first <= 0 &&  v[i - 1].second - v[i].second <= 0) {
                continue;
            }
            if (v[i - 1].first  - v[i].first < v[i - 1].second - v[i].second) {
                std::cout << -1 << std::endl;
                flag = false;
                break;
            }
        }

        if (!flag) {
            continue;
        }


        int max_diff = 0;
        for (int i = 0; i < n; ++i) {
            max_diff = std::max(max_diff, v[i].first - v[i].second);
        }
        std::cout << max_diff << std::endl;
    }
    return 0;
}
