#include <bits/stdc++.h>
using namespace std;

const int max_number = 1e9 + 8;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int max_p = max_number / 3;

    auto can = [&](int number) -> bool {
        vector<int> b = a;
        for (int i = 0; i < n; ++i) {
            b[i] -= number;
            if (b[i] < 0) {
                return false;
            }
        }

        for (int loop = 0; loop <= 33; ++loop) {
            for (int i = 0; i < n; ++i) {
                int next = i + 1;
                if (next == n) {
                    next = 0;
                }
                int prev = i - 1;
                if (prev < 0) {
                    prev = n - 1;
                }

                int max_2 = b[next] / 2;
                int after_subtraction = b[i] - max_2;
                if (after_subtraction > 0) {
                    int qan = (after_subtraction + 1) / 2;

                    b[i] -= 2 * qan;
                    b[prev] -= qan;
                    if (b[i] < 0 || b[prev] < 0) {
                        return false;
                    }
                }
            }
        }

        for (int i = 0; i < n; ++i) {
            assert(b[i] == 0);
        }
        return true;
    };

    int answer = 0;

    auto bin_poisk = [&](int plus) {
        int l = 0;
        int r = max_p - 1;
        int ans = -1;
        while (l <= r) {
            int mid = l + (r - l) / 2;
            int number = mid * 3 + plus;
            if (can(number)) {
                ans = number;
                l = mid + 1;
            } else {
                r = mid - 1;
            }
        }

        answer = max(answer, ans);
    };

    bin_poisk(0);
    bin_poisk(1);
    bin_poisk(2);

    cout << answer << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
