#include <bits/stdc++.h>
using namespace std;


void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> goes(n), comes(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        goes[u].push_back(v);
        comes[v].push_back(u);
    }

    set<int> first;
    vector<int> order_first;
    set<int> second;
    vector<int> order_second;

    vector<int> processed(n);
    for (int i = 0; i < n; ++i) {
        if (!goes[i].empty()) {
            int to = goes[i][0];
            processed[i] = processed[to] = 1;
            first.insert(i);
            order_first.push_back(i);
            second.insert(to);
            order_second.push_back(to);
            break;
        }
    }

    for (int i = 0; i < n; ++i) {
        if (processed[i] == 1) {
            continue;
        }
        int i_to_one = 0;
        int i_to_two = 0;
        for (int u : goes[i]) {
            if (first.contains(u)) {
                ++i_to_one;
            } else if (second.contains(u)) {
                ++i_to_two;
            }
        }
        int one_to_i = 0;
        int two_to_i = 0;
        for (int u : comes[i]) {
            if (first.contains(u)) {
                ++one_to_i;
            } else if (second.contains(u)) {
                ++two_to_i;
            }
        }
        if (i_to_one + i_to_two > two_to_i + one_to_i) {
            // putting in the first of one
            first.insert(i);
            order_first.push_back(i);
        } else {
            // putting at the end of two;
            second.insert(i);
            order_second.push_back(i);
        }
    }
    reverse(order_first.begin(), order_first.end());


    for (auto i : order_first) {
        cout << i + 1 << ' ';
    }
    for (auto i : order_second) {
        cout << i + 1 << ' ';
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
