#define _USE_MATH_DEFINES
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <unordered_set>
#include <queue>
#include <deque>
#include <string>
#include <sstream>
#include <iomanip>
#include <map>
#include <unordered_map>
#include <stack>
#include <cstdio>
#include <climits>
#include <tuple>
#include <ctime>
#include <cstring>
#include <numeric>
#include <functional>
#include <chrono>
#include <cassert>
#include <bitset>
#include <fstream>
#include <thread>
#include <immintrin.h>
#include <random>
#include <utility>
#include <list>
#define ff first
#define ss second
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define replr(i, a, b) for (int i = int(a); i <= int(b); ++i)
#define reprl(i, a, b) for (int i = int(a); i >= int(b); --i)
#define rep(i, n) for (int i = 0; i < int(n); ++i)
#define mkp(a, b) make_pair(a, b)
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> PII;
typedef vector<int> VI;
typedef vector<PII> VPI;
typedef vector<VI> VVI;
typedef vector<VVI> VVVI;
typedef vector<VPI> VVPI;
typedef pair<ll, ll> PLL;
typedef vector<ll> VL;
typedef vector<PLL> VPL;
typedef vector<VL> VVL;
typedef vector<VVL> VVVL;
typedef vector<VPL> VVPL;
template<class T> T setmax(T& a, T b) { if (a < b) return a = b; return a; }
template<class T> T setmin(T& a, T b) { if (a < b) return a; return a = b; }

const int MOD = 1e9 + 7;

vector<vector<int>> gp;

void solve() {
    ll n; cin >> n;
    vector<ll> h(n);
    vector<ll> p(n);
    vector<pair<ll, ll>> vp(n);
    for (int i = 0; i < n; ++i)cin >> h[i];
    for (int i = 0; i < n; ++i)cin >> p[i];
    for (int i = 0; i < n; ++i)
    {
        ll t = p[i] - h[i];
        if (t < 0)
        {
            cout << -1 << endl;
            return;
        }
        vp[i] = { t, p[i] };
    }

    sort(vp.begin(), vp.end());
    set<ll> dod;
    for (int i = 0; i < n; ++i)
    {
        ll cur = vp[i].second;
        if (i && vp[i].first == vp[i - 1].first && cur == vp[i - 1].second)
        {
            continue;
        }
        if (dod.lower_bound(cur) != dod.end())
        {
            cout << -1 << endl;
            return;
        }
        dod.insert(cur);
    }
    ll ans = 0;
    ll sum = 0;
    for (int i = 0; i < n; ++i)
    {
        if (sum >= vp[i].first)continue;
        ans += vp[i].first - sum;
        sum += vp[i].first - sum;
    }
    cout << ans << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int t = 1;
    cin >> t;
    while (t--) solve();
}
