#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <set>
#include <queue>

using namespace std;

using ll = long long;

void solve() {
	ll n;
	std::cin >> n;
	if (n == 2) {
		ll a, b;
		cin >> a >> b;
		ll step = abs(b - a);
		if (step < min(a, b)) {
			cout << min(a, b) - step;
		}
		else {
			cout << 0;
		}
		cout << endl;
		return;
	}
	std::vector<ll> v(n);
	std::vector<ll> diff(n);
	ll sum = 0;
	for (auto& x : v) {
		cin >> x;
		sum += x;
	}
	bool flag = false;
	for (ll k = 0; k <= 100 * n; ++k) {
		if ((3 * k) % n == sum % n) {
			flag = true;
			break;
		}
	}
	if (!flag) {
		cout << 0 << endl;
		return;
	}
	for (ll i = 0; i < n - 1; ++i) {
		diff[i] = v[i + 1] - v[i];
	}
	diff[n - 1] = v[0] - v[n - 1];
	ll i = 0;
	ll count = 0;
	ll limit = 0;
	ll sub_sum = 0;
	while (count < n && sum >= sub_sum) {
		if (diff[i] < 0) {
			count = 0;
			ll step = (1 - diff[i]) / 2;
			sub_sum += step * 3;
			diff[i] += step * 2;
			ll prev = i - 1;
			if (prev < 0) {
				prev += n;
			}
			diff[prev] -= step;
			ll prev_prev = i - 2;
			if (prev_prev < 0) {
				prev_prev += n;
			}
			diff[prev_prev] -= step;
		}
		--i;
		if (i == -1) {
			i = n - 1;
		}
		++count;
		++limit;
		if (limit > n * 1000) {
			cout << 0 << endl;
			return;
		}
	}
	if (sum < sub_sum) {
		cout << 0 << endl;
	}
	else {
		ll ans = (sum - sub_sum) / n;
		cout << ans << endl;
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	ll t;
	std::cin >> t;
	while (t-- > 0) {
		solve();
	}
}

/*
1
4
9 9 6 8
*/