#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <set>
#include <queue>

using namespace std;

using ll = long long;

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	int n;
	int k;
	std::cin >> n >> k;
	vector<string> v(n);
	for (int i = 0; i < n; ++i) {
		cin >> v[i];
	}
	vector<int> symbol_prefix(k);
	vector<bool> symbol_test(k);
	for (const auto &str : v) {
		char start_char = str[0];
		int count = 0;
		for (auto c : str) {
			if (c == start_char) {
				++count;
			}
			else {
				break;
			}
		}
		if (count == str.size()) {
			symbol_test[start_char - 'a'] = true;
		}
		symbol_prefix[start_char - 'a'] += count;
	}
	bool flag = std::all_of(symbol_test.begin(), symbol_test.end(), [](bool x) {return x;});
	if (flag) {
		cout << "NO\n";
		return 0;
	}
	auto it = std::min_element(symbol_prefix.begin(), symbol_prefix.end());
	char ans = (it - symbol_prefix.begin()) + 'a';
	for (int i = 0; i < *it + 1; ++i) {
		std::cout << ans;
	}
	cout << endl;
}
