#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <set>
#include <queue>

using namespace std;

using ll = long long;

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	int n;
	int k;
	std::cin >> n >> k;
	vector<string> v(n);
	for (int i = 0; i < n; ++i) {
		cin >> v[i];
	}
	vector<int> symbol_prefix(k, 0);
	vector<bool> symbol_test(k, false);
	for (const auto &str : v) {
		char start_char = str[0];
		int count = 0;
		for (auto c : str) {
			if (c == start_char) {
				++count;
			}
			else {
				break;
			}
		}
		if (count == str.size()) {
			symbol_test[start_char - 'a'] = true;
		}
		symbol_prefix[start_char - 'a'] += count;
	}
	bool flag = true;
	for (bool b : symbol_test) {
		if (!b) {
			flag = false;
			break;
		}
	}
	if (flag) {
		cout << "NO\n";
		return 0;
	}
	int minn = std::numeric_limits<int>::max();
	int index = 0;
	for (int i = 0; i < symbol_prefix.size(); ++i) {
		if (!symbol_test[i] && minn > symbol_prefix[i]) {
			minn = symbol_prefix[i];
			index = i;
		}
	}
	char ans = 'a' + index;
	for (int i = 0; i < minn + 1; ++i) {
		std::cout << ans;
	}
	cout << endl;
}
