#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main() {
    int t;
    cin >> t;
    vector<int> res;
    while (t--) {
        int n;
        cin >> n;

        vector<int> h(n), p(n);
        for (int i = 0; i < n; i++) {
            cin >> h[i];
        }
        for (int i = 0; i < n; i++) {
            cin >> p[i];
        }

        vector<pair<int, int>> dp(n);
        for (int i = 0; i < n; i++) {
            dp[i] = { p[i], h[i] };
        }

        sort(dp.begin(), dp.end(), [](const pair<int, int>& a, const pair<int, int>& b) {
            return b.first < a.first; 
            });

        bool flag = false;

        for (int i = 0; i < n - 1; i++) {
            if (dp[i].second < dp[i + 1].second) {
                flag = true;
                res.push_back(-1);
                break;
            }
        }

        vector<int> dif(n);

        if (!flag) {
            for (int i = 0; i < n; i++) {
                dif[i] = dp[i].first - dp[i].second;
                if (dif[i] < 0) {
                    flag = true;
                    res.push_back(-1);
                    break;
                }
            }
        }

        if (!flag) {
            for (int i = 0; i < n - 1; i++) {
                if (dif[i] < dif[i + 1]) {
                    res.push_back(-1);
                    flag = true;
                    break;
                }
            }
        }

        if (!flag) {
            res.push_back(dif[0]);
        }
    }
    for (const auto& i : res)
    {
        cout << i << endl;
    }
    return 0;
}