#include <iostream>
#include <string>
#include <cmath>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <stack>
#include <sstream>
#include <fstream>
#include <algorithm>

using namespace std;
bool get_smallest(const vector<int>& dif)
{
	int mn = 10e8;
	for (int i = 0; i < dif.size(); ++i)
	{
		mn = min(dif[i], mn);
	}
	return mn;
}

bool get_mount(const vector<int>& p, const vector<int>& dif, int mn)
{
	int mt = 10e8;
	for (int i = 0; i < p.size(); ++i)
	{
		if (dif[i] == mn && mt > p[i])
			mt = p[i];
	}
	return mt;
}

int main()
{
	int t;
	cin >> t;
	while (t--)
	{
		int n;
		cin >> n;
		vector<int> h(n);
		vector<int> p(n);
		vector<int> dif(n);
		for (int i = 0; i < n; ++i)
		{
			cin >> h[i];
		}
		for (int i = 0; i < n; ++i)
		{
			cin >> p[i];
			dif[i] = p[i] - h[i];
		}
		vector<pair<int, int>> a(n);
		for (int i = 0; i < n; ++i)
		{
			a[i].first = h[i];
			a[i].second = dif[i];
		}
		sort(a.begin(), a.end(), [](pair<int, int> lhs, pair<int, int> rhs) {return lhs.second > rhs.second;});

		
		bool d = false;
		for (int i = 0; i < n - 1; ++i)
		{
			if (a[i].first < a[i + 1].first && a[i].second != a[i+1].second)
			{
				d = true;
				cout << -1 << endl;
				break;
			}
		}
		if (!d)
			cout << a[0].second << endl;
	}
	return 0;
}
