#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <climits>
#include <utility>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>
#include <cassert>
#include <cstring>
#include <sstream>
#include <numeric>
#include <cstdio>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <functional>

using namespace std;

typedef int i8;
typedef unsigned int i16;
typedef long i32;
typedef long long i64;

i64 minut(string& s1, string& s2) {
	i64 t1 = (s1[0] - '0') * 60 + (s1[2] - '0') * 10 + s1[3] - '0';
	i64 t2 = (s2[0] - '0') * 60 + (s2[2] - '0') * 10 + s2[3] - '0';
	return t2 - t1;
}

int main() {
	std::ios_base::sync_with_stdio(0);
	std::cout.tie(0);
	std::cin.tie(0);
	i64 n;
	cin >> n;
	vector<string>v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}

	if (n == 1) {
		cout << 2 << endl;
		return 0;
	}
	if (n == 2) {
		if (minut(v[0], v[1]) > 10) {
			cout << 2 << endl;
		}
		else {
			cout << 1 << endl;
		}
		return 0;
	}
	i64 temp = LLONG_MAX;
	for (int i = 0; i < n - 2; i++) {
		if (minut(v[i], v[i + 2]) <= 10) {
			cout << 0 << endl;
			return 0;
		}
		if (minut(v[i], v[i + 2]) < temp) {
			temp = minut(v[i], v[i + 2]);
		}
	}
	if (temp <= 10) {
		cout << 0 << endl;
		return 0;
	}
	i64 temp2 = LLONG_MAX;
	for (int i = 0; i < n - 1; i++) {
		if (minut(v[i], v[i + 1]) < temp2) {
			temp2 = minut(v[i], v[i + 1]);
		}
	}
	if (temp2 <= 10) {
		cout << 1 << endl;
	}
	else {
		cout << 2 << endl;
	}
	return 0;
}