#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <climits>
#include <utility>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>
#include <cassert>
#include <cstring>
#include <sstream>
#include <numeric>
#include <cstdio>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <functional>

using namespace std;

typedef int i8;
typedef unsigned int i16;
typedef long i32;
typedef long long i64;

class Temp
{
public:
    i64 a;
    i64 b;

    Temp(i64 x = 0, i64 y = 0) : a(x), b(y)
    {

    }

    bool operator <(const Temp& other)
    {
        if (a < other.a)
            return true;

        if (a > other.a)
            return false;

        return b < other.b;
    }

    bool operator <=(const Temp& other)
    {
        if (a < other.a)
            return true;

        if (a > other.a)
            return false;

        return b <= other.b;
    }
};



int main() {
    std::ios_base::sync_with_stdio(0);
    std::cout.tie(0);
    std::cin.tie(0);
    i64 t;
    cin >> t;
    while (t--) 
    {
        i64 n;
        cin >> n;

        vector<i64>h(n);
        for (i64 i = 0; i < n; i++) {
            cin >> h[i];
        }

        vector<i64>p(n);
        for (i64 i = 0; i < n; i++) {
            cin >> p[i];
        }

        bool key = true;
        vector<Temp>v;
        for (i64 i = 0; i < n; i++) 
        {
            i64 dif = p[i] - h[i];
            if (dif < 0) 
            {
                cout << -1 << endl;
                key = false;
                break;
            }

            if (dif == 0) {
                v.push_back(Temp(h[i], dif));
            }
            else
            {
                v.push_back(Temp(h[i] + 1, dif));
            }
        }

        if (key == false) {
            continue;
        }

        sort(v.begin(), v.end());

        //for (auto& i : v)
        //{
        //    cout << i.a << " " << i.b << endl;
        //}

        key = true;
        for (int i = 0; i < v.size() - 1; i++)
        {
            if (v[i].a == v[i + 1].a && v[i].b == 0) {
                key = false;
                break;
            }
            if (v[i + 1].b < v[i].b)
            {
                key = false;
                break;
            }
        }


        std::cout << ((key == false) ? -1 : v[v.size() - 1].b) << std::endl;
       
    }

    return 0;
}