def time_to_minutes(t):
    h,m = map(int, t.split(':'))
    return (h-7) * 60 + m

def min_additional_alarms(n, alarms):
    alarm_times = sorted([time_to_minutes(alarm)
                          for alarm in alarms])
    for i in range(n-2):
        if alarm_times[i+2] - alarm_times[i] <= 10:
            return 0

    for i in range(n-1):
        if alarm_times[i + 1] - alarm_times[i] <= 10:
            return 1

    return 2

n = int(input())
alarms = [input().strip() for _ in range(n)]

print(min_additional_alarms(n, alarms))