#include <bits/stdc++.h>

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

template <typename T, typename Cmp = less<T>>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type,
    Cmp, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

static constexpr int N = 2e5 + 3;

static pair<int, int> a[N];
static int d[N];

void solve()
{
    int n; cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i].second;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i].first;
    }
    sort(a, a + n);
    int ans = 0;

    for (int i = 0; i < n; i++) {
        int diff = a[i].first - a[i].second;
        if (diff < 0) ans = 0;
        d[i] = diff;
    }
    for (int i = 1; i < n; i++) {
        if (a[i].first == a[i - 1].first) {
            if (d[i] != d[i-1]) {
                ans = -1;
                break;
            }
        }
        if (d[i] < d[i-1]) {
            ans = -1;
            break;
        }
    }

    for (int i = 1; i < n; i++) {
        if (a[i].second < a[i - 1].second)
            ans = -1;
    }
    if (ans != -1) {
        ans = d[n - 1];
    }
    cout<<ans<<endl;

}

int main()
{
    ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
    int T = 1;
    cin >> T;
    while (T-- > 0)
    {
        solve();
    }

    return 0;
}
