#include <bits/stdc++.h>

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

template <typename T, typename Cmp = less<T>>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type,
    Cmp, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

static constexpr int N = 2e5 + 3;

static pair<int, int> a[N];
static int d[N];

void solve()
{
    int n; cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i].second;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i].first;
    }
    sort(a, a + n, greater<pair<int, int>>());
    int ans = 0;
    for (int i = 0; i < n; i++) {
        d[i] = a[i].first - a[i].second;
        if (d[i] < 0) {
            ans = -1;
            break;
        }
        if (i > 0 && d[i] > d[i - 1]) {
            ans = -1;
            break;
        }
        if (i > 0 && a[i].first == a[i - 1].first && d[i] != d[i - 1]) {
            ans = -1;
            break;
        }
        if (i > 0 && a[i].second < a[i - 1].second) {
            ans = -1;
            break;
        }
    }

    if (ans != -1) {
        ans = d[0];
    }

    cout<<ans<<endl;

}

int main()
{
    ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
    int T = 1;
    cin >> T;
    while (T-- > 0)
    {
        solve();
    }

    return 0;
}

