#include <bits/stdc++.h>

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

template <typename T, typename Cmp = less<T>>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type,
    Cmp, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

static constexpr int N = 2e5 + 3;
//const int N=200010;
int used[N];
vector <int> g[N],ans,top_sort;

void dfs(int v) {

    used[v] = 1;
    for (int i = 0; i < (int)g[v].size(); i++) {
        int to = g[v][i];
        if (used[to]!=0) continue;
       // dis[to]=dis[v]+1;
        dfs(to);
    }
    top_sort.push_back(v);


}

void solve()
{

   int n,x,y,m;
   cin>>n>>m;
    top_sort.clear();
    set<int> se;
   for(int i=1;i<=n;i++) {
        used[i]=0;g[i].clear();
        se.insert(i);
   }
   for(int i=0;i<m;i++)
   {
       cin>>x>>y;

       g[x].push_back(y);
    }
    for(int i=1;i<=n;i++)
    {
        if(used[i]==0) dfs(i);
    }
    int cnt=0;
    for(int i = top_sort.size()-1;i>=0;i--)
    {
        int k = top_sort[i];
        for(int j=0;j<(int)g[k].size();j++){
            if(se.find(g[k][j])!=se.end()) cnt++;
        }
        se.erase(k);
    }
    //cout<<cnt<<endl;
    if(cnt>=(m+1)/2){
        for(int i = top_sort.size()-1;i>=0;i--) cout<<top_sort[i]<<' ';
    cout<<endl;
    }
   else cout<<-1<<endl;

}

int main()
{
    ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
    int T = 1;
    cin >> T;
    while (T-- > 0)
    {
        solve();
    }

    return 0;
}
