#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main() {
    int t;
    cin >> t;

    while (t--) {
        int n;
        cin >> n;

        vector<int> h(n);
        vector<int> p(n);


        for (int i = 0; i < n; ++i) {
            cin >> h[i];
        }

        for (int i = 0; i < n; ++i) {
            cin >> p[i];
        }

        int max_years = 0;
        bool possible = true;

        for (int i = 0; i < n; ++i) {
            if (p[i] < h[i]) {
                possible = false;
                break;
            }
            max_years = max(max_years, p[i] - h[i]);
        }

        if (possible) {
            cout << max_years << endl;
        } else {
            cout << -1 << endl;
        }
    }

    return 0;
}
