def erosion_years(t, test_cases):
    results = []
    for case in test_cases:
        n, h, p = case
        years = 0
        possible = True
        for i in range(n):
            if h[i] > p[i]:
                possible = False
                break
            years = max(years, p[i] - h[i])
        results.append(years if possible else -1)
    return results

# Input handling
t = int(input())
test_cases = []
for _ in range(t):
    n = int(input())
    h = list(map(int, input().split()))
    p = list(map(int, input().split()))
    test_cases.append((n, h, p))

# Solve and print results
results = erosion_years(t, test_cases)
for res in results:
    print(res)