#include <bits/stdc++.h>
using namespace std;
#define m_p make_pair
#define fi first
#define se second
#define all(x) (x).begin(),(x).end()
#define sz(x) ((int)(x).size())
typedef long long ll;
mt19937 rnf(2106);
const int N = 400005, M = 998244353;

struct ban
{
    int a[2][2];
    ban()
    {
        for (int i = 0; i < 2; ++i)
            for (int j = 0; j < 2; ++j)
                a[i][j] = 0;
    }
};
ban operator*(const ban& a, const ban& b)
{
    ban res;
    for (int i = 0; i < 2; ++i)
    {
        for (int j = 0; j < 2; ++j)
        {
            for (int k = 0; k < 2; ++k)
            {
                res.a[i][j] = (res.a[i][j] + a.a[i][k] * 1LL * b.a[k][j]) % M;
            }
        }
    }
    return res;
}

ban ast(ban x, int n)
{
    ban ans;
    for (int i = 0; i < 2; ++i)
        ans.a[i][i] = 1;
    while (n)
    {
        if (n % 2 == 1)
            ans = ans * x;
        x = x * x;
        n /= 2;
    }
    return ans;
}

int ast(int x, int n)
{
    int ans = 1;
    while (n)
    {
        if (n % 2 == 1)
            ans = (ans * 1LL * x) % M;
        x = (x * 1LL * x) % M;
        n /= 2;
    }
    return ans;
}

ban t0;

int n, m, k;
vector<int> v;
pair<int, int> b[N];

bool so(const pair<int, int>& a, const pair<int, int>& b)
{
    return m_p(a.fi, -a.se) < m_p(b.fi, -b.se);
}

int maxu[N * 4];
void bil(int tl, int tr, int pos)
{
    maxu[pos] = 0;
    if (tl == tr)
        return;
    int m = (tl + tr) / 2;
    bil(tl, m, pos * 2);
    bil(m + 1, tr, pos * 2 + 1);
}

void ubd(int tl, int tr, int x, int y, int pos)
{
    maxu[pos] = max(maxu[pos], y);
    if (tl == tr)
        return;
    int m = (tl + tr) / 2;
    if (x <= m)
        ubd(tl, m, x, y, pos * 2);
    else
        ubd(m + 1, tr, x, y, pos * 2 + 1);
}

int qry(int tl, int tr, int l, int r, int pos)
{
    if (l > r)
        return 0;
    if (tl == l && tr == r)
        return maxu[pos];
    int m = (tl + tr) / 2;
    return max(qry(tl, m, l, min(m, r), pos * 2),
               qry(m + 1, tr, max(m + 1, l), r, pos * 2 + 1));
}

int p[N];

int T0(int n)
{
    ban t = ast(t0, n);
    return (k * 1LL * t.a[0][0]) % M;
}
int T1(int n)
{
    ban t = ast(t0, n);
    return (k * 1LL * t.a[1][0]) % M;
}

int s;
int ans;
vector<int> g[N];
void dfs(int x)
{
    for (int i = 0; i < g[x].size(); ++i)
    {
        int h = g[x][i];
        int n = v[b[h].se - 1] - v[b[h].fi - 1];
        for (int i = 0; i < g[h].size(); ++i)
        {
            int hh = g[h][i];
            n -= (v[b[hh].se - 1] - v[b[hh].fi - 1] - 1);
        }
        ans = (ans * 1LL * T1(n)) % M;
        ans = (ans * 1LL * ast(k, M - 2)) % M;
        ans = (ans * 1LL * ast((k - 1), M - 2)) % M;
        s += (n - 1);
        dfs(h);
    }
}

void solv()
{
    cin >> n >> m >> k;

    for (int i = 0; i <= m + 1; ++i)
        g[i].clear();
    v.clear();

    for (int i = 1; i <= m; ++i)
        cin >> b[i].fi >> b[i].se;

    t0.a[0][0] = 0;
    t0.a[0][1] = 1;
    t0.a[1][0] = k - 1;
    t0.a[1][1] = k - 2;

    b[0] = m_p(1, n);
    for (int i = 1; i <= m; ++i)
    {
        if (b[i].fi > b[i].se)
            swap(b[i].fi, b[i].se);
    }

    v.clear();
    for (int i = 0; i <= m; ++i)
    {
        v.push_back(b[i].fi);
        v.push_back(b[i].se);
    }
    sort(all(v));
    for (int i = 0; i <= m; ++i)
    {
        b[i].fi = lower_bound(all(v), b[i].fi) - v.begin() + 1;
        b[i].se = lower_bound(all(v), b[i].se) - v.begin() + 1;
    }

    sort(b, b + m + 1, so);
    bil(1, sz(v), 1);
    for (int i = 0; i <= m; ++i)
    {
        if (i == 0)
            p[i] = 0;
        else
            p[i] = qry(1, sz(v), b[i].se, sz(v), 1);
        ubd(1, sz(v), b[i].se, i, 1);
    }

    /*cout << "###########################\n";
    for (int i = 0; i <= m; ++i)
    {
        cout << b[i].fi << ' ' << b[i].se << "\n";
        cout << p[i] << "\n";
    }
    cout << "###########################\n";*/

    for (int i = 1; i <= m; ++i)
        g[p[i]].push_back(i);
    s = n;
    for (int i = 1; i <= m; ++i)
    {
        if (p[i] == 0)
        {
            s -= (v[b[i].se - 1] - v[b[i].fi - 1] - 1);
        }
    }

    ans = T0(s);
    dfs(0);

    cout << ans << "\n";
}

int main()
{
    #ifdef GOOD
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    #endif // GOOD

    int tt = 1;
    cin >> tt;
    while (tt--)
    {
        solv();
    }
    return 0;
}
