//#include <iostream>
//#include <algorithm>
//#include <string>
//#include <cstring>
//#include <vector>
//#include <set>
//
//using namespace std;
//
//const int N = 200005;
//const int inf = 1000 * 1000 * 1000;
//const double eps = 1e-9;
//
//int t;
//int n;
//
//int x[N], cnt[N];
//char c[N];
//
//int main() {
//	ios_base::sync_with_stdio(false);
//	cin.tie(NULL);
//
//	cin >> t;
//	while (t--) {
//		cin >> n;
//
//		long long all_b = 0;
//		long long all_r = 0;
//
//		for (int i = 1; i <= n; i++) {
//			cin >> x[i] >> cnt[i] >> c[i];
//			if (c[i] == 'R') {
//				all_r += cnt[i];
//			}
//			else {
//				all_b += cnt[i];
//			}
//		}
//
//		if (all_r == all_b) {
//			cout << "Draw 0 0" << endl;
//			continue;
//		}
//
//		if (all_r < all_b) {
//			vector < pair<int, int> > st;
//
//			long long total = 0;
//			long long counter = 0;
//
//			for (int i = n; i >= 1; i--) {
//				if (c[i] == 'R') {
//					counter += cnt[i];
//				}
//				else {
//					counter -= cnt[i];
//					total += cnt[i] * 1ll * c[i];
//				}
//
//				if (counter > 0) {
//					
//				}
//				else {
//					total -= cnt[i] * 1ll * c[i];
//				}
//			}
//			
//			if (c[n] == 'R') {
//				cout << "Draw " << x[n] << " +" << endl;
//				continue;
//			}
//
//
//
//			continue;
//		}
//
//
//	}
//
//	cin >> n;
//	return 0;
//}

#include <iostream>
#include <algorithm>
#include <string>
#include <cstring>
#include <vector>
#include <set>

using namespace std;

const int N = 200005;
const int inf = 1000 * 1000 * 1000;
const double eps = 1e-9;

int t;
int n;
int a[N], x[N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	cin >> t;
	while (t--) {
		cin >> n;

		long long sum = 0;
		for (int i = 1; i <= n; i++) {
			cin >> a[i];
			sum += a[i];
		}

		if (n == 2) {
			int mn = min(a[1], a[2]);
			cout << max(0, mn - abs(a[1] - a[2])) << endl;
			continue;
		}

		int mx = -1, ind;
		for (int i = 1; i <= n; i++) {
			int nxt = (i == n) ? 1 : (i + 1);
			x[i] = a[i] - a[nxt];

			if (x[i] > mx) {
				mx = x[i];
				ind = i;
			}
		}

		if (mx == 0) {
			cout << a[1] << endl;
			continue;
		}

		long long total = 0;
		int counter = n;

		while (counter--) {
			if (x[ind] <= 0) {
				ind = (ind == 1) ? n : (ind - 1);
				continue;
			}
			
			int val = (x[ind] + 1) / 2;
			total += val;

			x[ind] -= 2 * val;
			x[(ind - 1 <= 0) ? (ind - 1 + n) : (ind - 1)] += val;
			x[(ind - 2 <= 0) ? (ind - 2 + n) : (ind - 2)] += val;

			ind = (ind == 1) ? n : (ind - 1);
		}

		bool flag = true;
		for (int i = 1; i <= n; i++) {
			if (x[i] != 0) {
				flag = false;
				break;
			}
		}

		if (flag) {
			cout << (sum - total * 3) / n << endl;
		}
		else {
			cout << 0 << endl;
		}
	}

	cin >> n;
	return 0;
}
