#include <iostream>
#include <algorithm>
#include <string>
#include <cstring>
#include <vector>
#include <set>

using namespace std;

const int N = 200005;
const int inf = 1000 * 1000 * 1000;
const double eps = 1e-9;

int t;
int n;
int a[N], b[N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	cin >> t;
	while (t--) {
		cin >> n;

		vector < pair<int, int> > arr;
		for (int i = 1; i <= n; i++) {
			cin >> a[i];
		}

		int mx = 0;
		for (int i = 1; i <= n; i++) {
			cin >> b[i];
			mx = max(mx, b[i] - a[i]);
			arr.emplace_back(b[i], b[i] - a[i]);
		}

		sort(arr.begin(), arr.end());

		bool flag = true;
		int lst = 0;

		for (int i = 0; i < (int)arr.size(); i++) {
			int x = arr[i].first;
			set <int> vals;
			while (i < (int)arr.size() && arr[i].first == x) {
				vals.insert(arr[i].second);
				++i;
			}
			--i;

			if ((int)vals.size() != 1) {
				flag = false;
				break;
			}

			if (*vals.begin() < lst) {
				flag = false;
				break;
			}

			lst = *vals.begin();
		}

		if (flag) {
			cout << mx << endl;
		}
		else {
			cout << -1 << endl;
		}
	}

	cin >> n;
	return 0;
}
