#include <iostream>
#include <algorithm>
#include <string>
#include <cstring>
#include <vector>
#include <set>

using namespace std;

const int N = 100005;
const int inf = 1000 * 1000 * 1000;
const double eps = 1e-9;

int t;
int n, m;
set <int> g[N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	cin >> t;
	while (t--) {
		cin >> n >> m;

		for (int i = 1; i <= m; i++) {
			int a, b;
			cin >> a >> b;
			g[b].insert(a);
		}

		int cnt = 0;
		for (int i = 1; i <= n; i++) {
			for (int to : g[i]) {
				if (to < i) {
					++cnt;
				}
			}
		}

		if (cnt >= m - cnt) {
			for (int i = 1; i <= n; i++) {
				cout << i << " ";
			}
			cout << endl;
		}
		else {
			for (int i = n; i >= 1; i--) {
				cout << i << " ";
			}
			cout << endl;
		}

		for (int i = 1; i <= n; i++) {
			g[i].clear();
		}
	}

	cin >> n;
	return 0;
}
