#include <iostream>
#include <algorithm>
#include <string>
#include <cstring>
#include <vector>
#include <set>

using namespace std;

const int N = 105;
const int inf = 1000 * 1000 * 1000;
const double eps = 1e-9;

int t;
int n, e;
string s[N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	cin >> n >> e;
	for (int i = 1; i <= n; i++) {
		cin >> s[i];
	}

	int answ = inf;
	char ch;

	for (int i = 0; i < e; i++) {
		char x = char(i + 'a');

		int sum = 0;
		bool flag = true;
		for (int j = 1; j <= n; j++) {
			bool found = false;
			for (int h = 0; h < (int)s[j].size(); h++) {
				if (s[j][h] != x) {
					found = true;
					sum += h;
					break;
				}
			}
			if (!found) {
				flag = false;
				break;
			}
		}

		if (!flag) continue;

		if (sum + 1 < answ) {
			answ = sum + 1;
			ch = x;
		}
	}

	if (answ == inf) {
		cout << "NO" << endl;
		return 0;
	}

	for (int i = 1; i <= answ; i++) {
		cout << ch;
	}
	cout << endl;

	cin >> n;
	return 0;
}
