#include <iostream>
#include <vector>
#include <cmath>
using namespace std;
long long disrtance (int x1, int y1, int x2, int y2) {
    return (long long)(x2 - x1)*(x2-x1) + (long long)(y2 - y1)*(y2 - y1);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int cases;
    cin >> cases;
    while (cases--) {
        int num;
        cin >> num;
        vector<tuple<int, int, int>> circles(num) ;
        for (int i = 0; i < num; ++i) {
            int x, y, radius;
            cin >> x >> y >> radius;
            circles[i] = make_tuple(x, y, radius);
        }
        int count = 0;
        for (int c1 = 0; c1 < num-1; ++c1) {
            int x1, y1, r1;
            tie(x1, y1, r1) = circles[c1];
            for (int c2 = c1+1; c2 < num; ++c2) {
                int x2, y2, r2;
                tie(x2, y2, r2) = circles[c2];
                long long dist_sq = disrtance(x1, y1, x2, y2);
                if((long long)(r1+r2)*(r1+r2) == dist_sq) {
                    count++;
                }
            }
        }
        cout << count << endl;
    }
    return 0;
}
