import java.util.Arrays;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int t = scanner.nextInt();
        int[] out = new int[t];
        for(int i = 0; i < t; i++) {
            int n = scanner.nextInt();
            int[] h = new int[n];
            int[] p = new int[n];
            for(int j = 0; j < n; j++) {
                h[j] = scanner.nextInt();
            }
            for(int j = 0; j < n; j++) {
                p[j] = scanner.nextInt();
            }
            int ans = 0;
            int x = -1;
            while (!isErrorFound(p,x) && !isSolutionFound(p,h)) {
                x = findX(p,h);
                decrementAll(p,x);
                ans++;
            }
            if(isErrorFound(p,x)) {
                out[i] = -1;
            }
            else {
                out[i] = ans;
            }
        }
        for(int i = 0; i < t; i++) {
            System.out.println(out[i]);
        }
    }
    private static boolean isErrorFound(int[] p, int x) {
        boolean found = true;
        for (int j : p) {
            if (j == 0) {
                return true;
            }
            if(j > x) {
                return false;
            }
        }
        return found;
    }
    private static boolean isSolutionFound(int[] p, int[] h) {
        for(int i = 0; i < h.length; i++) {
            if(h[i] != p[i]) {
                return false;
            }
        }
        return true;
    }
    private static int findX(int[] p, int[] h) {
        int x = -1;
        for (int i = 0; i < p.length; i++) {
            if (p[i] == h[i] && p[i] > x) {
                x = p[i];
            }
        }
        return x+1;
    }
    private static void decrementAll(int[] arr, int x) {
        for(int i = 0; i < arr.length; i++) {
            if(arr[i] >= x) {
                arr[i]--;
            }
        }
    }
}