#include <algorithm>
#include <iostream>
#include <vector>

int main() {
    // std::ios_base::sync_with_stdio(false);
    int t;
    std::cin >>t;
    while (t--) {
        int n;
        std::cin >> n;
        std::vector<std::pair<int, int>> v(n);
        for (int i = 0; i < n; i++) {
            std::cin >> v[i].second;
        }
        for (int i = 0; i < n; i++) {
            std::cin >> v[i].first;
        }
        std::sort(v.begin(), v.end());
        // for (int i = 1; i < n; i++) {
        //     if (v[i].second < v[i - 1].second) {
        //         std::cout << -1 << std::endl;
        //     }
        // }
        std::vector<int> diff1(n - 1);
        for (int i = 1; i < n; i++) {
            diff1[i - 1] = v[i].first - v[i - 1].first;
        }
        std::vector<int> diff2(n - 1);
        for (int i = 1; i < n; i++) {
            diff2[i - 1] = v[i].second - v[i - 1].second;
        }
        bool flag = true;
        for (int i = 0; i < n - 1; ++i) {
            if (diff2[i] > diff1[i]) {
                std::cout << -1 << std::endl;
                flag = false;
                break;
            }
        }
        if (!flag) {
            continue;
        }
        int max_diff = 0;
        for (int i = 0; i < n; ++i) {
            max_diff = std::max(max_diff, std::abs(v[i].first - v[i].second));
        }
        std::cout << max_diff << std::endl;
    }
    return 0;
}
