#include <bits/stdc++.h>
using namespace std;

bool check_sorted(vector<int>& v) {
    bool ok = true;
    for (int i = 1; i < v.size(); i++) {
        if (v[i] < v[i - 1]) {
            ok = false;
            break;
        }
    }
    return ok;
}

void solve() {
    int n;
    cin >> n;
    vector<int> v1(n), v2(n);
    vector<pair<int, pair<int, int>>> s;
    for (auto &i : v1) {
        cin >> i;
    }
    for (auto &i : v2) {
        cin >> i;
    }
    bool ok = true;
    for (int i = 0; i < n; i++) {
        if (v2[i] < v1[i]) {
            ok = false;
            break;
        }
        s.push_back({v2[i] - v1[i], {v2[i], v1[i]}});
    }
    if (!ok) {
        cout << "-1\n";
        return;
    }
    // sort(s.begin(), s.end(), [&](pair<int, pair<int, int>> &a, pair<int, pair<int, int>> &b) {
    //     if (a.first != b.first)
    //         return a.first < b.first;
    //     if (a.second.first != b.second.first)
    //         return a.second.first < b.second.first;
    //     return a.second.second < b.second.second;
    // });
    sort(s.begin(), s.end());
    vector<int> v3(n), v4(n);
    for (int i = 0; i < n; i++) {
        v3[i] = s[i].second.first;
        v4[i] = s[i].second.second;
    }
    ok = check_sorted(v3);
    if (!ok) {
        cout << "-1\n";
        return;
    }
    ok = check_sorted(v4);
    if (!ok) {
        cout << "-1\n";
        return;
    }
    cout << s.back().first << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
