#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <set>
#include <chrono>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <string>
#include <deque>
#include <vector>
using namespace std;

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int N = 2e5 + 10;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    vector<pair<long long, long long>> pr(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        pr[i].first = a[i];
    }

    for (int i = 0; i < n; i++)
    {
        cin >> b[i];
        pr[i].second = b[i];
    }


    sort(pr.begin(), pr.end());

    for (int i = 1; i < n; i++)
    {
        if (pr[i].first > pr[i - 1].first)
        {
            if (pr[i - 1].second > pr[i].second)
            {
                cout << -1 << endl;
                return;
            }
        }
    }

    long long pi = pr[n - 1].second - pr[n - 1].first;
    long long ans = pi;
    for (int i = n - 2; i >= 0; i--)
    {
        long long need = pr[i].second - pr[i].first;
        long long cur = min(pi, pr[i].second - pr[i].first);
        ans += max(0ll, need - cur);
    }
    cout << ans << '\n';
}
int main()
{
    fastIO();
    int t = 1;

    cin >> t;
    while (t--) {
        solve();
    }
	return 0;
}