#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <set>
#include <chrono>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <string>
#include <deque>
#include <vector>
#include <cassert>
using namespace std;


#ifndef ONLINE_JUDGE
#define dbg(x)         \
    cerr << #x << " "; \
    print(x);          \
    cerr << endl;
#else
#define dbg(x)
#endif

#define sz(x)   (int((x).size()))
#define len(x)  (int)x.length()
#define all(x)  (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define clr(x)  (x).clear()
#define uniq(x) x.resize(unique(all(x)) - x.begin());
#define blt(x)  __builtin_popcount(x)

#define pb   push_back
#define popf pop_front
#define popb pop_back

void print(long long t)
{
    cerr << t;
}

void print(int t)
{
    cerr << t;
}

void print(string t)
{
    cerr << t;
}

void print(char t)
{
    cerr << t;
}

void print(double t)
{
    cerr << t;
}

void print(long double t)
{
    cerr << t;
}

void print(unsigned long long t)
{
    cerr << t;
}

template <class T, class V> void print(pair<T, V> p);
template <class T> void print(vector<T> v);
template <class T> void print(set<T> v);
template <class T, class V> void print(map<T, V> v);
template <class T> void print(multiset<T> v);

template <class T, class V> void print(T v[], V n)
{
    cerr << "[";
    for (int i = 0; i < n; i++)
    {
        print(v[i]);
        cerr << " ";
    }
    cerr << "]";
}

template <class T, class V> void print(pair<T, V> p)
{
    cerr << "{";
    print(p.first);
    cerr << ",";
    print(p.second);
    cerr << "}";
}

template <class T> void print(vector<T> v)
{
    cerr << "[ ";
    for (T i : v)
    {
        print(i);
        cerr << " ";
    }
    cerr << "]";
}

template <class T> void print(deque<T> v)
{
    cerr << "[ ";
    for (T i : v)
    {
        print(i);
        cerr << " ";
    }
    cerr << "]";
}

template <class T> void print(set<T> v)
{
    cerr << "[ ";
    for (T i : v)
    {
        print(i);
        cerr << " ";
    }
    cerr << "]";
}

template <class T> void print(multiset<T> v)
{
    cerr << "[ ";
    for (T i : v)
    {
        print(i);
        cerr << " ";
    }
    cerr << "]";
}

template <class T, class V> void print(map<T, V> v)
{
    cerr << "[ ";
    for (auto i : v)
    {
        print(i);
        cerr << " ";
    }
    cerr << "]";
}

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int N = 2e5 + 10;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    vector<pair<long long, long long>> pr(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        pr[i].second = a[i];
    }

    bool flag = false;
    for (int i = 0; i < n; i++)
    {
        cin >> b[i];
        pr[i].first = b[i];

        if (a[i] > b[i])
        {
            flag = true;
        }
    }

    if (flag)
    {
        cout << -1 << '\n';
        return;
    }

    sort(pr.begin(), pr.end());
    long long lst = pr[0].first - pr[0].second, ans = lst;
    for (int i = 1; i < n; i++)
    {
        ans = max(ans, pr[i].first - pr[i].second);
        if (pr[i].first == pr[i - 1].first)
        {
            if (pr[i].second != pr[i - 1].second)
            {
                cout << -1 << '\n';
                return;
            }
        }

        long long cur = pr[i].first - pr[i].second;
        if (cur < lst)
        {
            cout << -1 << '\n';
            return;
        }
        lst = cur;
    }
    //assert(ans == lst);
    cout << ans << '\n';
}
int main()
{
    fastIO();
    int t = 1;

    cin >> t;
    while (t--) {
        solve();
    }
	return 0;
}