#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <set>
#include <chrono>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <string>
#include <deque>
#include <vector>
using namespace std;

void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int N = 2e5 + 10;
vector<int> adj[N];
void solve() {
    int n, m;
    cin >> n >> m;

    for (int i = 1; i <= m; i++)
    {
        int a, b;
        cin >> a >> b;
        adj[a].push_back(b);
    }

    int k = 0;
    for (int i = 1; i <= n; i++)
    {
        for (auto j : adj[i])
        {
            if (i < j)
            {
                k++;
            }
        }
    }

    int pt = (m + 1) / 2;
    if (k >= pt)
    {
        for (int i = 1; i <= n; i++)
        {
            cout << i << " ";
        }
        cout << endl;
    }
    else
    {
        for (int i = n; i >= 1; i--)
        {
            cout << i << " ";
        }
        cout << endl;
    }
}
int main()
{
    fastIO();
    int t = 1;

    cin >> t;
    while (t--) {
        solve();
    }
	return 0;
}