
#include <cassert>
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <cfenv>
#include <cinttypes>
#include <cstdint>
#include <cwchar>
#include <cwctype>
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <type_traits>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <numeric>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <limits.h>
#include <climits>

short interval(const std::string& time1, const std::string& time2)
{
	std::string m1 = std::string(time1.begin() + 2, time1.end());
	int minute1 = time1[0] * 60 + std::stoi(m1);
	std::string m2 = std::string(time2.begin() + 2, time2.end());
	int minute2 = time2[0] * 60 + std::stoi(m2);
	return minute2 - minute1;
}

int main()
{
	std::ios_base::sync_with_stdio(0);
	std::cout.tie(0);
	std::cin.tie(0);
	int n;
	std::cin >> n;
	std::vector<std::string> alarms(n);
	for (int i = 0; i < n; ++i)
	{
		std::cin >> alarms[i];
	}
	if (n == 1)
	{
		std::cout << 2;
		return 0;
	}
	if (n == 2)
	{
		if (interval(alarms[0], alarms[1]) <= 10)
		{
			std::cout << 1;
			return 0;
		}
		else {
			std::cout << 2;
			return 0;
		}
	}
	int minInterval = INT_MAX;
	for (int i = 0; i < n - 2; ++i)
	{
		int inter = interval(alarms[i], alarms[i + 2]);
		if (inter <= 10)
		{
			std::cout << 0;
			return 0;
		}
		else if(interval(alarms[i], alarms[i + 1]) <= 10 || interval(alarms[i + 1], alarms[i + 2]) <= 10)
		{
			/*if (inter <= minInterval)
			{
				minInterval = inter;
			}*/
			std::cout << 1;
			return 0;
		}
		else
		{
			std::cout << 2;
			return 0;
		}
	}
}