//#include <cassert>
//#include <cctype>
//#include <cerrno>
//#include <cfloat>
//#include <climits>
//#include <clocale>
//#include <cmath>
//#include <csetjmp>
//#include <csignal>
//#include <cstdarg>
//#include <cstddef>
//#include <cstdio>
//#include <cstdlib>
//#include <cstring>
//#include <ctime>
//#include <cfenv>
//#include <cinttypes>
//#include <cstdint>
//#include <cwchar>
//#include <cwctype>
//#include <algorithm>
//#include <bitset>
//#include <complex>
//#include <deque>
//#include <exception>
//#include <fstream>
//#include <functional>
//#include <iomanip>
//#include <ios>
//#include <iosfwd>
//#include <iostream>
//#include <istream>
//#include <iterator>
//#include <limits>
//#include <list>
//#include <locale>
//#include <map>
//#include <memory>
//#include <new>
//#include <numeric>
//#include <ostream>
//#include <queue>
//#include <set>
//#include <sstream>
//#include <stack>
//#include <stdexcept>
//#include <streambuf>
//#include <string>
//#include <typeinfo>
//#include <type_traits>
//#include <utility>
//#include <valarray>
//#include <vector>
//#include <array>
//#include <atomic>
//#include <chrono>
//#include <condition_variable>
//#include <forward_list>
//#include <future>
//#include <initializer_list>
//#include <mutex>
//#include <random>
//#include <ratio>
//#include <regex>
//#include <scoped_allocator>
//#include <system_error>
//#include <thread>
//#include <tuple>
//#include <typeindex>
//#include <type_traits>
//#include <numeric>
//#include <unordered_map>
//#include <unordered_set>
//#include <string>
//#include <limits.h>
//#include <climits>
//
//int main()
//{
//	std::ios_base::sync_with_stdio(0);
//	std::cout.tie(0);
//	std::cin.tie(0);
//	int t;
//	std::cin >> t;
//
//	int n;
//	std::vector<int> v1;
//	std::vector<int> v2;
//	std::map<int, int> distances;
//
//	std::vector<int> results;
//	while (t--)
//	{
//		v1.clear();
//		v2.clear();
//		distances.clear();
//		std::cin >> n;
//		
//		for (int i = 0; i < n; ++i)
//		{
//			int val;
//			std::cin >> val;
//			v1.push_back(val);
//		}
//		bool isLoopBroke = false;
//		int maxDiff = INT_MIN;
//		for (int i = 0; i < n; ++i)
//		{
//			int val;
//			std::cin >> val;
//			v2.push_back(val);
//			if (v2[i] - v1[i] < 0)
//			{
//				results.push_back(-1);
//				isLoopBroke = true;
//				break;
//			}
//			distances[v2[i]] = v2[i] - v1[i];
//			if (distances[v2[i]] > maxDiff)
//				maxDiff = distances[v2[i]];
//		}
//
//		if (isLoopBroke)
//			continue;
//
//		bool isBraked = false;
//		auto prevIt = std::prev(distances.end());
//		for (auto it = distances.begin(); it != prevIt; ++it)
//		{
//			if (it->second > std::next(it)->second)
//			{
//				results.push_back(-1);
//				isBraked = true;
//				break;
//			}
//		}
//		if (isBraked)
//		{
//			continue;
//		}
//		else
//		{
//			results.push_back(maxDiff);
//			continue;
//		}
//
//
//		if (n == 1)
//		{
//			if (v2[0] - v1[0] < 0)
//			{
//				results.push_back(-1);
//				continue;
//			}
//			else {
//
//				results.push_back(v2[0] - v1[0]);
//
//				continue;
//			}
//		}
//		v1.clear();
//		v2.clear();
//		distances.clear();
//	}
//	for (const auto& i : results)
//	{
//		std::cout << i << std::endl;
//	}
//}
#include <iostream>
#include <vector>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    vector<int> results;


    while (t--) {
        int n;
        cin >> n;

        vector<int> h(n), p(n);
        for (int i = 0; i < n; ++i) cin >> h[i];
        for (int i = 0; i < n; ++i) cin >> p[i];

        int max_diff = 0;
        bool possible = true;

        for (int i = 0; i < n; ++i) {
            if (h[i] > p[i]) {
                possible = false;
                break;
            }
            max_diff = max(max_diff, p[i] - h[i]);
        }

        if (!possible) {
            results.push_back(-1);
            continue;
        }

        int minHeight = INT_MAX;
        for (int i = 0; i < n; ++i) 
        {
            if (p[i] - h[i] == max_diff)
            {
                if (p[i] <= minHeight)
                {
                    minHeight = p[i];
                }
            }
        }


        bool isBrake = false;
        for (int i = 0; i < n; ++i)
        {
            if (p[i] >= minHeight)
            {
                if (p[i] - h[i] != max_diff)
                {
                    results.push_back(-1);
                    isBrake = true;
                    break;
                }
            }
        }
        if (isBrake)
        {
            continue;
        }


        results.push_back(possible ? max_diff : -1);
    }

    for (const auto& i : results)
        std::cout << i << std::endl;
    return 0;
}