#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <climits>
#include <utility>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>
#include <cassert>
#include <cstring>
#include <sstream>
#include <numeric>
#include <cstdio>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <functional>

using namespace std;

typedef int i8;
typedef unsigned int i16;
typedef long i32;
typedef long long i64;

i64 minut(string& s1, string& s2) {
	i64 t1 = (s1[0] - '0') * 60 + (s1[2] - '0') * 10 + s1[3] - '0';
	i64 t2 = (s2[0] - '0') * 60 + (s2[2] - '0') * 10 + s2[3] - '0';
	return t2 - t1;
}



int main() {
	std::ios_base::sync_with_stdio(0);
	std::cout.tie(0);
	std::cin.tie(0);
	i64 t;
	cin >> t;
	while (t--) {
		i64 n;
		cin >> n;
		vector<i64>h(n);
		for (i64 i = 0; i < n; i++) {
			cin >> h[i];
		}
		vector<i64>p(n);
		for (i64 i = 0; i < n; i++) {
			cin >> p[i];
		}
		vector<pair<i64, i64>>v;
		for (i64 i = 0; i < n; i++) {
			i64 dif = p[i] - h[i];
			if (dif < 0) {
				cout << -1 << endl;
				return 0;
			}
			if (dif == 0) {
				v.push_back(make_pair(h[i], 0));
			}
			else {
				v.push_back(make_pair(h[i] + 1, dif));
			}
		}
		sort(v.begin(), v.end());
		i64 mv = LLONG_MIN;
		bool eq = false;
		for (i64 i = 0; i < n - 1; i++) {
			if (v[i + 1].first == v[i].first) {
				mv = max(v[i + 1].second, v[i].second);
				eq = true;
			}
			else {
				if (eq == true) {
					if (v[i + 1].second < mv) {
						cout << -1 << endl;
						return 0;
					}
					eq = false;
				}
				else {
					if (v[i + 1].second < v[i].second) {
						cout << -1 << endl;
						return 0;
					}
				}
			}
		}
		cout << v[n - 1].second << endl;
	}
	
	return 0;
}