#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <climits>
#include <utility>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>
#include <cassert>
#include <cstring>
#include <sstream>
#include <numeric>
#include <cstdio>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <functional>

using namespace std;

typedef int i8;
typedef unsigned int i16;
typedef long i32;
typedef long long i64;



int main() {
	std::ios_base::sync_with_stdio(0);
	std::cout.tie(0);
	std::cin.tie(0);
	i64 n, e;
	cin >> n >> e;
	vector<string>vec(n);
	set<char>s;
	set<char>q;
	for (int i = 0; i < n; i++) {
		cin >> vec[i];
	}
	sort(vec.begin(), vec.end());
	for (int i = 0; i < vec.size(); i++) {
		bool key = false;
		q.insert(vec[i][0]);
		for (int j = 0; j < vec[i].size() - 1; j++) {
			if (vec[i][j] != vec[i][j + 1]) {
				key = true;
				break;
			}
		}
		if (key == false) {
			s.insert(vec[i][0]);
		}
	}
	if (s.size() == e) {
		cout << "NO" << endl;
		return 0;
	}
	for (int i = 0; i < e; i++) {
		if (q.find(i + 'a') == q.end()) {
			cout << (char)(i + 'a') << endl;
			return 0;
		}
	}
	vector<int>y(e, 0);
	for (int i = 0; i < e; i++) {
		for (int j = 0; j < vec.size(); j++) {
			for (int q = 0; q < vec[j].size(); q++) {
				if (vec[j][q] != ('a' + i))
					break;

				y[i]++;
			}
		}
	}
	int mini = INT_MAX;
	int index = 0;
	for (int i = 0; i < y.size(); i++) {
		if (mini > y[i]) {
			index = i;
			mini = y[i];
		}
	}
	for (int i = 0; i < mini + 1; i++) {
		cout << (char)('a' + index);
	}
	cout << endl;
	return 0;
}