test_cases = []

tests_no = int(input())
for i in range(tests_no):
    mountain_count = int(input())
    current_heights = list(map(int, input().split()))
    old_heights = list(map(int, input().split()))
    test_cases.append({
        "mountain_count": mountain_count,
        "current_heights": current_heights,
        "old_heights": old_heights
    })

for test_case in test_cases:
    mountain_count = test_case["mountain_count"]
    current_heights = test_case["current_heights"]
    old_heights = test_case["old_heights"]
    erosions_list = []
    for i in range(mountain_count):
        erosion = old_heights[i] - current_heights[i]
        # Erosion can't be negative
        if erosion < 0:
            erosions_list = [-1]
            break
        erosions_list.append(erosion)

    # Check if erosion values are consistent
    if -1 in erosions_list:
        print(-1)
    else:
        # Find the maximum erosion required
        max_erosion = max(erosions_list)
        consistent = True
        for i in range(mountain_count):
            if old_heights[i] - max_erosion > current_heights[i]:
                consistent = False
                break

        print(max_erosion if consistent else -1)
