
import math

def count_tangential_circles(circles):
    count = 0
    
    for i in range(len(circles)):
        x1, y1, r1 = circles[i]
        for j in range(i + 1, len(circles)):
            x2, y2, r2 = circles[j]
            
            d = math.sqrt((x2 - x1) ** 2 + (y2 - y1) ** 2)
            
            if (d == r1 + r2 or d == abs(r1 - r2)) and d > abs(r1 - r2):
                count += 1
                
    return count

testCount = int(input())
for test in range(testCount):
    circlesCount = int(input())
    circles = []
    for circle in range(circlesCount):
        circleCoordsInput = input()
        circles.append(tuple(int(x) for x in circleCoordsInput.split(" ")))
    print(count_tangential_circles(circles))

